use tokio::join;

pub mod bms;
pub mod emu;
pub mod pcs;

pub type Producer = tokio::sync::mpsc::Sender<String>;
pub type Consumer = tokio::sync::broadcast::Receiver<String>;
#[async_trait::async_trait]
pub trait Service: Send + Sync {
    async fn serve(&self) {
        let read_task = self.read_task();
        let write_task = self.write_task();
        let _ = join!(read_task, write_task);
    }

    async fn read_task(&self);

    async fn write_task(&self);
}
